﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Syncfusion.Blazor;
using UrlAdaptor.Data;

namespace UrlAdaptor.Controller
{

    [ApiController]
    public class ValuesController : ControllerBase
    {
        public ValuesController()
        {
            BindDataSource();
        }
        public static List<EmployeeData> order = new List<EmployeeData>();
        [HttpPost]
        [Route("api/[controller]")]
        public object Post([FromBody] DataManagerRequest dm)
        {
            if (order.Count == 0)
            {
                BindDataSource();
            }
            IEnumerable DataSource = order.ToList();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = DataOperations.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = DataOperations.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = DataOperations.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<EmployeeData>().Count();
            if (dm.Skip != 0)
            {
                DataSource = DataOperations.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = DataOperations.PerformTake(DataSource, dm.Take);
            }
            return new { result = DataSource, count = count };

        }

        [HttpPost]
        [Route("api/Default/Update")]
        public void Update([FromBody] CRUDModel<EmployeeData> value)
        {
            var re = Request;
            var headers = re.Headers;
            var data = order.Where(or => or.Id == value.Value.Id).FirstOrDefault();
            if (data != null)
            {
                data.Id = value.Value.Id;
                data.Name = value.Value.Name;
                data.Title = value.Value.Title;
            }
        }

        [HttpPost]
        [Route("api/Default/Insert")]
        public void Insert([FromBody] CRUDModel<EmployeeData> value)
        {
            order.Insert(0, value.Value);
        }

        [HttpPost]
        [Route("api/Default/Delete")]
        public void Delete([FromBody] CRUDModel<EmployeeData> value)
        {
           order.Remove(order.Where(or => or.Id == Convert.ToInt32(value.Key)).FirstOrDefault());   
        }

        public class CRUDModel<T> where T : class
        {

            [JsonProperty("action")]
            public string Action { get; set; }
            [JsonProperty("table")]
            public string Table { get; set; }
            [JsonProperty("keyColumn")]
            public string KeyColumn { get; set; }
            [JsonProperty("key")]
            public object Key { get; set; }
            [JsonProperty("value")]
            public T Value { get; set; }
            [JsonProperty("added")]
            public List<T> Added { get; set; }
            [JsonProperty("changed")]
            public List<T> Changed { get; set; }
            [JsonProperty("deleted")]
            public List<T> Deleted { get; set; }
            [JsonProperty("params")]
            public IDictionary<string, object> Params { get; set; }
        }
        private void BindDataSource()
        {           
            if (order.Count == 0)
            {
                order = Enumerable.Range(1, 9).Select(x => new EmployeeData()
                {
                    Id = x,
                    Name = new EmployeeName()
                    {
                        FirstName = x,      
                        Text = (new string[] { "ALFKI", "VINET", "BLONP", "BOLID", "WELLI" })[new Random().Next(5)],
                    },
                    Title = (new string[] { "Sales Representative", "Vice President Sales", "Sales Manager",
                                          "Inside Sales Coordinator" })[new Random().Next(4)],
                }).ToList();
            }
        }

    }
}

